---
id: pull-request
---

# How to Contribute

## Reporting Bugs

If you find a bug, we strongly encourage you to report it to the project maintainers. You can do this by creating a new issue on the project's issue tracker, or by sending a pull request with a fix for the bug.
It is always helpful to provide as much information as possible when reporting bugs, and it would help a lot
if you could provide an example that demonstrates the bug.

## I would like to contribute code - how do I do this?

Fork the repository, make your change and submit a pull request. Before submitting the pull request:

- make sure that your changes are well tested and that you have updated the project's documentation.
- make sure your tests (`yarn run test`) and build (`yarn run build`) are properly working locally on your machine and make sure they all pass

## Any guidance on submitting changes?

While we do appreciate code contributions, triaging and integrating contributed code changes can be very time consuming. Please consider the following tips when working on your pull requests:

- Functionality is appropriate for the repository. Consider posting on the forum if you are not sure.
- Code quality is acceptable. We don't have coding standards defined, but make sure it passes ESLint and looks like the rest of the code in the repository.
- Quality of design is acceptable. This is a bit subjective so you should consider posting on the forum for specific guidance.
- The scope of the pull request is not too large. Please consider separate pull requests for each feature as big pull requests are very time consuming to understand.
- We will provide feedback on your pull requests as soon as possible. Following the tips above will help ensure your changes are reviewed.
